/**
 * \file
 *
 * \brief DALI]up
 *
 * 쌠 (C) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

/**
 * \mainpage
 *
 * \section intro 
 *
 * ̉pDALI]u@\܂B]uDALI呕uƒʐMĖ߂s
 * ܂B߂͓d͐A`ԐݒA₢킹Aꖽ߂܂݂܂Bڍׂɂ
 * ĂIEC62386KiQƂĂB
 *
 * :EEPROM̔j邽߁AōBODقɐݒ肳ׂłB
 *
 * \section contactinfo ₢킹
 * XȂɂĂ<A href="http://www.atmel.com/">Atmel</A>K˂Ă
 * B\n
 */

#include "compiler.h"
#include "dali_top.h"
#include "dali_tc.h"
#include "dali_bit.h"

void system_init(void);
void param_init(void);

/*! \brief JԂ̺
 *
 *  ̊֐DALI]uK܂B
 *
 */
int main(void)
{
	cli();
	system_init();
	param_init();
	sei();
	while (1) {
		dali_process_power_on();
		dali_frame_process_state();
		dali_process_interface_failure();
	}
}

/**
 * \brief я
 *
 * ̊֐͸ۯAI/OAv01A荞݂Ȃǂ܂B
 */
void system_init(void)
{
	/* 8KHzƂۯ */
	CLKPR = 1 << CLKPCE;
	CLKPR = 0;
	/* ًx~ */
	SMCR = (1 << SE);
	/* d͍팸 */
	/* PRSPIޯWireŐݒ肷邱Ƃł܂B! */
	/* PRR = (1 << PRTWI) | (1 << PRTIM2) | (1 << PRSPI) | (1 << PRUSART0); */
	PRR = (1 << PRTWI) | (1 << PRTIM2) | (1 << PRUSART0);

	dali_bit_init();
	dali_tc_init();
}

/**
 * \brief  Ұ
 *
 * ̊֐Ұƕϐ܂B
 */
void param_init(void)
{
	dali_frame_init();
}
