/**
 * \file
 *
 * \brief PCINTײ
 *
 * 쌠 (c) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef PCINT_H
#define PCINT_H

typedef void (*pcint_callback_t)(void);

/* ݕω߰ */
enum pcint_module_t {
	PCINT_PIN_7_0 = 0,
	PCINT_PIN_14_8 = 1,
	PCINT_PIN_23_16 = 2,
};

/* ݕω荞݋ޯ */
enum pcint_pcie_t {
	PCINT_PCIE_PIN_7_0 = PCIE0,
	PCINT_PCIE_PIN_14_8 = PCIE1,
	PCINT_PCIE_PIN_23_16 = PCIE2,
};

/* ݕω荞ݐݒ */
enum pcint_set_t {
	PCINT_DISABLE = 0,
	PCINT_ENABLE = 1,
};

/**
 * \brief PCINTωݐݒ
 *
 * \param  pcmsk ݕω߰
 * \param  pin   ω
 * \param  set   ݒ܂͉
 */
void pcint_set_pin_change(enum pcint_module_t pcmsk, uint8_t pin,
		enum pcint_set_t set);

/**
 * \brief PCINT荞ݐݒ
 *
 * \param  pcie PCINT荞݋ޯ
 * \param  set  ݒ܂͉
 */
void pcint_set_interrupt(enum pcint_pcie_t pcie, enum pcint_set_t set);

/**
 * \brief PCINT荞݌Ăі߂֐ݒ
 *
 * ̊֐͊荞݌Ăі߂֐̐ݒƕύXĂяoɋ܂BĂі߂
 * ̐ݒȂײނ̊荞ݏ͊荞ݗv׸ނ邾łB
 *
 * \param  pcint    ݕϊ߰
 * \param  callback Ăі߂֐ւ̎Q
 */
void pcint_interrupt_callback(enum pcint_module_t pcint,
		pcint_callback_t callback);

#endif /* PCINT_H */
